<?php
/**
 * @copyright (c) Kufer Software GmbH, Oderstraße 7, D-84453 Mühldorf
 */

namespace Kufer\Web\KuferTools\Dozent\KursUebersicht\Detailsreiter\Termine\BerichtAbgeben\Senden;

class SendeKurstagBerichtAbgebenController extends \Kufer\Web\KuferTools\Basis\Controller\AjaxToolController
{
  protected function getUseCase(): \Kufer\Web\KuferTools\Basis\UseCase\UseCase
  {
    return new SendeKurstagBerichtAbgebenUseCase($this->getRequestObj());
  }

  protected function getRequestObj()
  {
    $result = new SendeKurstagBerichtAbgebenRequest();
    $result->ktId = \GetOperations::getVarValue('ktId');
    $result->dozenten = \JsonOperations::decodeBase64JustString(
      \PostOperations::getVarValue('kurstagBerichtAbgebenDozenten_hidden', '')
    );
    $result->anzahlKinder = \PostOperations::getVarValue('anzahl_kinder');
    $result->alterVon = \PostOperations::getVarValue('alter_von');
    $result->alterBis = \PostOperations::getVarValue('alter_bis');
    $result->bericht = \StringOperations::substr(\PostOperations::getVarValue('bericht'), 0, 1900);

    return $result;
  }

  protected function getPresenter($pUseCaseResponse)
  {
    return new SendeKurstagBerichtAbgebenPresenter($pUseCaseResponse);
  }
}